#include <stdio.h>
#include <unistd.h>
#include <asm/io.h>

#ifndef IOBASE
  #define IOBASE 0x378;
#endif

#define IOMIN 0x100
#define IOMAX 0x400

int iobase=IOBASE; /* LPT1 IO BASE ADDR */

void help() {
  printf(
	 "\n"
	 "Phone control programm v0.1 (for phone on/off device)\n"
	 "\n"
	 "(c) of device,     Sergej Pipets 1997,\n"
	 "(c) of utility,    Sergej.Pipets@p73.f195.n5030.z2.fidonet.org 1997,\n"
	 "(c) of linux port, <Dmitry Prokhorov> dip@spb.runnet.ru 1997\n"
	 "\n"
	 "Usage:   phonectl [-p<iobase>] <on|off>\n"
	 "Example: phonectl -p0x2e8 off\n"
	 "Return:  0 = success, 1 = invalid syntax, 2 = wrong iobase range,\n"
	 "         3 = i/o permittion error\n"
	 "\n"
	 "WARNING: <iobase> should be in range of 0x%03x..0x%03x !\n"
	 "\n"
	 , IOMIN, IOMAX);
}

void off() {
  if(iopl(3)) {
    perror("OFF command error");
    exit(3);
  }
  outb(0x02 | inb(iobase+2), iobase+2);
  outb(0xff, iobase);
  iopl(0);
}

void on() {
  if(iopl(3)) {
    perror("ON command error");
    exit(3);
  }
  outb(0xfd & inb(iobase+2), iobase+2);
  outb(0x00, iobase);
  iopl(0);
}

int main(int ac, char **av) {
  if(ac < 2 || ac > 3) {
    help();
    return 1;
  }
  if(*av[1] == '-' && ac < 3) {
    help();
    return 1;
  }
  if((char*)strstr(av[1], "-p0x") != av[1] && ac == 3) {
    help();
    return 1;
  }
  if(ac == 3) {
    iobase=(int)strtol(av[1]+2, (char**)NULL, 16);
    if(iobase < IOMIN || iobase > IOMAX) {
      printf("error: illegal iobase addres..\n");
      return 2;
    }
  }
  if( strcmp(av[ac-1], "off") == 0) {
    off();
    return 0;
  }
  if( strcmp(av[ac-1], "on") == 0) {
    on();
    return 0;
  }
  help();
  return 1;
}

/* eof */
